#include <hmg.ch>

*------------------------
function RaportyCOK
	if lPracownikCOK
		Raport_z_COK()
	else
		RaportDoRD()
	endif
 return
*----------------------------------
function Raport_z_COK

	private nLiczbaPozycjiRaportu := 0, lZatwierdzonoRaport := .f., lWydrukowanoRaport := .f.
	
	private aFieldsRaport, aHeadersRaport, aTypesRaport, aWidthsRaport, aControlsRaport, aRaport
	private aZatwRaportyFields, aZatwRaportyHeaders, aZatwRaportyTypes, aZatwRaportyWidths, aZatwRaportyControls, aZatwRaporty
	private aPozRaportowFields, aPozRaportowHeaders, aPozRaportowTypes, aPozRaportowWidths, aPozRaportowControls, aPozRaportow
	
	aFieldsRaport	:= {"NrDz","RkDz","DataWplywu","NrDz_Znak","Kli_Nazwa","Dotyczy","NrKolejny"}
	aHeadersRaport	:= {"Nr Dz.", "Rk Dz.", "D. Wpywu", "Znak", "Klient","Dotyczy","NrKolejny"}
	aTypesRaport	:= {"C", "C", "D", "C", "C", "C","N"}
	aWidthsRaport	:= { 60, 60, 80, 100, 190, 190,0}
	aControlsRaport	:= {	{"TEXTBOX","CHARACTER", 6} ,;
					{"TEXTBOX","CHARACTER", 6} ,;
					{"TEXTBOX","DATE"} ,;
					{"TEXTBOX","CHARACTER"} ,;
					{"TEXTBOX","CHARACTER"} ,;
					{"TEXTBOX","CHARACTER"} ,;
					{"TEXTBOX","NUMERIC", "99999"} }
	aRaport := {}
	
	aZatwRaportyFields	:= {"NrKolejny","DataRaportu"}
	aZatwRaportyHeaders	:= {"Id. Raportu", "Data"}
	aZatwRaportyTypes	:= { "N", "D" }
	aZatwRaportyWidths	:= { 80, 80 }
	aZatwRaportyControls	:= { 	{"TEXTBOX","NUMERIC", "99999"} , {"TEXTBOX","DATE"} }
	aZatwRaporty	:= {}
	
	aPozRaportowFields	:= {"pozrapcok.NrKolejny","pozrapcok.NrKolejnyRaportu", "pozrapcok.NrKolejnyPisma", "pisma.NrDz","pisma.Rkdz" , ;
						"pisma.DataWplywu",;
						"pisma.NrDz_Znak",;
						"pisma.Kli_Nazwa","pisma.Dotyczy"}
						
	aPozRaportowHeaders	:= {"NrKol", "Id.R.", "NrKolejnyPisma","Nr dz.", "Rk Dz.", "D.Wpywu", "Znak", "Klient", "Dotyczy"}
	aPozRaportowTypes	:= { "N", "N" ,"N", "C","C","D", "C", "C","C"}
	aPozRaportowWidths	:= { 0, 50 , 0, 60, 50, 60, 100, 150,150}
	aPozRaportowControls	:= { 	{"TEXTBOX","NUMERIC", "99999"} , {"TEXTBOX","NUMERIC", "99999"} , {"TEXTBOX","NUMERIC", "99999"} ,;
							{"TEXTBOX","CHARACTER"} ,{"TEXTBOX","CHARACTER"} ,;
							{"TEXTBOX","DATE"} ,{"TEXTBOX","CHARACTER"} ,;
							{"TEXTBOX","CHARACTER"} ,{"TEXTBOX","CHARACTER"}   }
	aPozRaportow	:= {}
	
	load window OKNORAPORTCOK
	center window OKNORAPORTCOK

	#ifndef DEBUG
		ON KEY ESCAPE of OknoRaportCOK ACTION OknoRaportCOK.RELEASE
	#endif

	activate window OKNORAPORTCOK
	
 return
*------------------------
function GenerujRaportCOK

	if lZatwierdzonoRaport .and. !lWydrukowanoRaport
		if !MsgYesNo("Wygenerowany i zatwierdzony raport nie zosta wydrukowany! Kontynuowa?","Pytanie",.T.)
			return
		endif
	endif
	
	do case
		case OknoRaportCOK.R_KtorePisma.Value == 1
			// wszystkie nieprzekazane
			cWarunekSQL := "RejestracjaCOK=1 and PotwierdzoneRD=0"
		case OknoRaportCOK.R_KtorePisma.Value == 2
			cWarunekSQL := "RejestracjaCOK=1 and PotwierdzoneRD=0 and DataWplywu>="+;
							c2sql(OknoRaportCOK.D_OdDnia.Value)+;
							" and DataWplywu <= "+c2sql(OknoRaportCOK.D_DoDnia.Value)
		otherwise
			// to si nie zdarzy
			return
	endcase
	
	lZatwierdzonoRaport	:= .f.
	lWydrukowanoRaport	:= .f.
	
	aRaport := SQL_GetArray("pisma", aFieldsRaport, aTypesRaport,cWarunekSQL,"NrKolejny")
	// odwieenie grida
	//msgbox(hb_valtoexp(aRaport))
	nLiczbaPozycjiRaportu := len(aRaport)
	OknoRaportCOK.G_Raport.DeleteAllItems()
	if nLiczbaPozycjiRaportu = 0
		MsgStop("Nie znaleziono pism do przekazania do RD!")
	else
		AEval(aRaport, { |x|  OknoRaportCOK.G_Raport.AddItem(x) } )
	endif
	
 return
 
*---------------------------
function ZatwierdzRaportCOK
	
	local i
	if lZatwierdzonoRaport
		MsgStop("Ten raport by ju zatwierdzony!")
		return
	endif
	
	if nLiczbaPozycjiRaportu = 0
		MsgStop("Brak pozycji raportu do zatwierdzenia!")
		return
	endif
	if !MsgYesNo("Czy jeste pewien, e chcesz przekaza pisma do RD?","Pytanie",.T.)
		return
	endif
	
	// ustal identyfikator raportu - numer kolejny
	if !SQL_ZapisRekordu("rapcok", {"DataRaportu"},{date()} )
		MsgStop("Zapis raportu nie powid si!")
		return
	endif

	OknoRaportCOK.T_IdentyfikatorRaportu.Value := RapCOK_NrKolejny
	
	for i := 1 to len(aRaport)
		if SQL_ZapisRekordu("pozrapcok", {"NrKolejnyRaportu", "NrKolejnyPisma"}, {RapCOK_NrKolejny,  aRaport[i,7] })
			//SQL_PoprawaRekordu("pisma" ,{ "PotwierdzoneRD"},{ rapcok_NrKolejny }, "NrKolejny="+str(aRaport[i,7]))
			// T operacj przenosimy do potwierszania przez 
		endif
	next i
	
	lZatwierdzonoRaport := .t.
 return .t.
*--------------------------
function DrukujPonownieRaportCOK
	local nRow, xItem, nNrRaportu, i
	private aRaport := {}
	
	nRow	:= OknoRaportCOK.G_ZatwRaporty.Value
	if nRow = 0
		return
	endif

	xItem := OknoRaportCOK.G_ZatwRaporty.Item(nRow)
	//msgbox("wiersz: "+str(nRow)+" item: "+hb_valtoexp(xItem))
	nNrRaportu := xItem[1]
	for i:= 1 to len(aPozRaportow)
		aadd(aRaport, {;
			aPozRaportow[i,4],;
			aPozRaportow[i,5],;
			aPozRaportow[i,6],;
			aPozRaportow[i,7],;
			aPozRaportow[i,8],;
			aPozRaportow[i,9]   } )
	next i
	DrukujRaportCOK(nNrRaportu)
 return
*--------------------------
function DrukujRaportCOK
	param nIdentyfikatorRaportu
	local lPodgladNaEkranie := .t.
	
	lWydrukowanoRaport := .t.
	
	aH1	:= {"Nr Dz.", "Rk Dz.", "Data", "Znak", "Klient","Dotyczy"}
	aH2	:= {"", "", "Wpywu", "", "",""}
	aW	:= { 15, 15, 20 ,30 , 55, 50, 0	 }
	aWiersze	:= {	{"right(aRow[1],6)" , "right(aRow[2],4)", "dtoc(aRow[3])", "left(aRow[4],15)", "left(aRow[5],25)", "left(aRow[6],25)" } ,;
				{ "", "", "",  "substr(aRow[4],16,15)" , "substr(aRow[5],26,25)", "substr(aRow[6],26,25) "},;
				{ "", "", "","substr(aRow[4],31,15)", "substr(aRow[5],51,25)", "substr(aRow[6],51,25) "} ,;
				{ "", "", "","substr(aRow[4],46,15)", "substr(aRow[5],76,25)", "substr(aRow[6],76,25) "} ;
				}
	nLewyMargines := 10
	
	naglowek := "Raport przekazania pism do RD nr " + alltrim(str(nIdentyfikatorRaportu))
	
	if lPodgladNaEkranie
		SELECT PRINTER DEFAULT ;
			PAPERSIZE PRINTER_PAPER_A4 ;
			PREVIEW
	else
		SELECT PRINTER DEFAULT ;
			PAPERSIZE PRINTER_PAPER_A4 ;
			PREVIEW
	endif

	START PRINTDOC NAME "Raport przekazania pism do RD"
	//START PRINTPAGE
	DlTab := len(AH1)

	Skok1 := 4
	Skok05:= 4
	DlStrony := 290
	lp := 0
	str := 0
	DrukujNaglowek := .t.
	
	for n := 1 to len(aRaport)
		aRow := aRaport[n]

		if DrukujNaglowek
			START PRINTPAGE
			str++
			@ 10,190 PRINT "str.:"+str(str,4) FONT "Arial CE" SIZE 12 BOLD RIGHT
			@ 10,25 PRINT "wygenerowano dnia: "+dtoc(date()) FONT "Arial CE" SIZE 8
			@ 25,25 PRINT naglowek FONT "Arial CE" SIZE 12 BOLD ITALIC

			PozycjaPoziom := nLewyMargines

			for i := 1 to DlTab
				@ 32,PozycjaPoziom+1 PRINT AH1[i] FONT "Arial CE" SIZE 8 BOLD ITALIC
				@ 38,PozycjaPoziom+1 PRINT AH2[i] FONT "Arial CE" SIZE 8 BOLD ITALIC
				PozycjaPoziom += AW[i]
			next i

			// poziome kreski nagwka
			@ 30,nLewyMargines PRINT LINE ;
					TO 30,PozycjaPoziom ;
					PENWIDTH 0.2 

			@ 45,nLewyMargines PRINT LINE ;
					TO 45,PozycjaPoziom ;
					PENWIDTH 0.2

			PozycjaPion := 45
			DrukujNaglowek := .f.

		endif
	
		lp++
altd()
		for wiersz:=1 to len(aWiersze)
			PozycjaPoziom := nLewyMargines
			for i := 1 to DlTab
				pole := aWiersze[wiersz,i]
				if empty(pole)
					pole := ""
				else
					pole := &(pole)
				endif
				
				@ PozycjaPion,PozycjaPoziom+1 PRINT pole FONT "Arial CE" SIZE 8
				PozycjaPoziom += AW[i]
			next i
			PozycjaPion +=Skok05
		next wiersz
altd()
		@ PozycjaPion,nLewyMargines PRINT LINE ;
					TO PozycjaPion,PozycjaPoziom ;
					PENWIDTH 0.2 
		
		if PozycjaPion + Skok1+ skok05 > DlStrony
altd()
			@ PozycjaPion,nLewyMargines PRINT LINE ;
					TO PozycjaPion,PozycjaPoziom ;
					PENWIDTH 0.2
				DrukujNaglowek := .t.

				// drukuj linie pionowe

				PozycjaPoziom := nLewyMargines
				for i := 1 to DlTab+1
					@ 30, PozycjaPoziom Print LINE ;
						TO PozycjaPion,PozycjaPoziom ;
						PENWIDTH 0.2
					PozycjaPoziom += AW[i]
				next i

				END PRINTPAGE

		endif
	next n

	if !DrukujNaglowek
		@ PozycjaPion,nLewyMargines PRINT LINE ;
				TO PozycjaPion,PozycjaPoziom ;
				PENWIDTH 0.2
		// drukuj linie pionowe
		PozycjaPoziom := nLewyMargines
		for i := 1 to DlTab+1
			@ 30, PozycjaPoziom - 0.5 Print LINE ;
				TO PozycjaPion,PozycjaPoziom - 0.5 ;
				PENWIDTH 0.2
			PozycjaPoziom += AW[i]
		next i
	endif
	@PozycjaPion, 190 PRINT "*** koniec raportu***" FONT "Arial CE" SIZE 8 ITALIC RIGHT
	pracuje("")
	END PRINTPAGE
	END PRINTDOC
 return .f.	
return
*--------------------------
function PrzygotujTabeleRaportow
	
	if OknoRaportCOK.T_RaportyCOK.Value == 2
		aZatwRaporty := SQL_GetArray("rapcok", aZatwRaportyFields, aZatwRaportyTypes,,"NrKolejny desc")
		OknoRaportCOK.G_ZatwRaporty.DeleteAllItems()
		AEval(aZatwRaporty, { |x|  OknoRaportCOK.G_ZatwRaporty.AddItem(x) } )
		//if !empty(aZatwRaporty)
		//	aPozRaportow := SQL_GetArray("pozrapcok", aPozRaportowFields, aPozRaportowTypes,"NrKolejnyRaportu="+str(aZatwRaporty[1,1]))
		//else
		//	aPozRaportow := {}
		//endif
		
		//OknoRaportCOK.G_PozRaportow.DeleteAllItems()
		//AEval(aPozRaportow, { |x|  OknoRaportCOK.G_PozRaportow.AddItem(x) } )
	endif
 return
 
*--------------------------
function OdswiezPozRaportow
	local cWarunekSQL := "", nRow, xItem
	
	if OknoRaportCOK.G_ZatwRaporty.Value > 0
		nRow	:= OknoRaportCOK.G_ZatwRaporty.Value
		xItem := OknoRaportCOK.G_ZatwRaporty.Item(nRow)
		//msgbox("wiersz: "+str(nRow)+" item: "+hb_valtoexp(xItem))
		cWarunekSQL := "pozrapcok.NrKolejnyRaportu="+ str( xItem[1]) + " and pisma.NrKolejny = pozrapcok.NrKolejnyPisma"
		//msgbox(cWarunekSQL)
		aPozRaportow := SQL_GetArray("pozrapcok, pisma", aPozRaportowFields, aPozRaportowTypes,;
				cWarunekSQL)
		OknoRaportCOK.G_PozRaportow.DeleteAllItems()
		AEval(aPozRaportow, { |x|  OknoRaportCOK.G_PozRaportow.AddItem(x) } )
	endif
 return
 
*--------------------------

function RaportDoRD
private nLiczbaPozycjiRaportu := 0, lZatwierdzonoRaport := .f., lWydrukowanoRaport := .f.
	
	private aZatwRaportyFields, aZatwRaportyHeaders, aZatwRaportyTypes, aZatwRaportyWidths, aZatwRaportyControls, aZatwRaporty
	private aPozRaportowFields, aPozRaportowHeaders, aPozRaportowTypes, aPozRaportowWidths, aPozRaportowControls, aPozRaportow
	
	aZatwRaportyFields	:= {"NrKolejny","DataRaportu"}
	aZatwRaportyHeaders	:= {"Id. Raportu", "Data"}
	aZatwRaportyTypes	:= { "N", "D" }
	aZatwRaportyWidths	:= { 80, 80 }
	aZatwRaportyControls	:= { 	{"TEXTBOX","NUMERIC", "99999"} , {"TEXTBOX","DATE"} }
	aZatwRaporty	:= {}
	
	aPozRaportowFields	:= {"pozrapcok.NrKolejny","pozrapcok.NrKolejnyRaportu", "pozrapcok.NrKolejnyPisma", "pisma.NrDz","pisma.Rkdz" , ;
						"pisma.DataWplywu",;
						"pisma.NrDz_Znak",;
						"pisma.Kli_Nazwa","pisma.Dotyczy"}
						
	aPozRaportowHeaders	:= {"NrKol", "Id.R.", "NrKolejnyPisma","Nr dz.", "Rk Dz.", "D.Wpywu", "Znak", "Klient", "Dotyczy"}
	aPozRaportowTypes	:= { "N", "N" ,"N", "C","C","D", "C", "C","C"}
	aPozRaportowWidths	:= { 0, 50 , 0, 60, 50, 60, 100, 150,150}
	aPozRaportowControls	:= { 	{"TEXTBOX","NUMERIC", "99999"} , {"TEXTBOX","NUMERIC", "99999"} , {"TEXTBOX","NUMERIC", "99999"} ,;
							{"TEXTBOX","CHARACTER"} ,{"TEXTBOX","CHARACTER"} ,;
							{"TEXTBOX","DATE"} ,{"TEXTBOX","CHARACTER"} ,;
							{"TEXTBOX","CHARACTER"} ,{"TEXTBOX","CHARACTER"}   }
	aPozRaportow	:= {}
	
	load window OKNORAPORTDoRD
	center window OKNORAPORTDoRD

	#ifndef DEBUG
		ON KEY ESCAPE of OknoRaportDoRD ACTION OknoRaportDoRD.RELEASE
	#endif
	
	PrzygotujTabeleRaportowDoRD()
	
	activate window OknoRaportDoRD
	
 return
*------------------------

function PrzygotujTabeleRaportowDoRD
	WAIt window "Trwa odwieanie tabel" NOWAIT
	aZatwRaporty := SQL_GetArray("rapcok", aZatwRaportyFields, aZatwRaportyTypes,;
			"PotwierdzoneRD = 0","NrKolejny desc")
	OknoRaportDoRD.G_ZatwRaporty.DeleteAllItems()
	AEval(aZatwRaporty, { |x|  OknoRaportDoRD.G_ZatwRaporty.AddItem(x) } )
	OknoRaportDoRD.G_ZatwRaporty.Value := 1
	WAIT CLEAR
 return
 
*--------------------------
function OdswiezPozRaportowDoRD
	local cWarunekSQL := "", nRow, xItem
	
	if OknoRaportDoRD.G_ZatwRaporty.Value > 0
		nRow	:= OknoRaportDoRD.G_ZatwRaporty.Value
		xItem := OknoRaportDoRD.G_ZatwRaporty.Item(nRow)
		//msgbox("wiersz: "+str(nRow)+" item: "+hb_valtoexp(xItem))
		cWarunekSQL := "pozrapcok.NrKolejnyRaportu="+ str( xItem[1]) + " and pisma.NrKolejny = pozrapcok.NrKolejnyPisma"
		//msgbox(cWarunekSQL)
		aPozRaportow := SQL_GetArray("pozrapcok, pisma", aPozRaportowFields, aPozRaportowTypes,;
				cWarunekSQL)
		OknoRaportDoRD.G_PozRaportow.DeleteAllItems()
		AEval(aPozRaportow, { |x|  OknoRaportDoRD.G_PozRaportow.AddItem(x) } )
		
	endif
 return
 
*--------------------------

function PobierzRaportDoRD
	
	local nRow, xItem, nNrRaportu
	local cSQL := ""
	
	nRow	:= OknoRaportDoRD.G_ZatwRaporty.Value
	if nRow = 0
		return
	endif
	
	cNrRaportu := alltrim(str(OknoRaportDoRD.G_ZatwRaporty.Item(nRow)[1]))

	if !MsgYesNo("Czy jeste pewien, e pobierasz raport o numerze: "+cNrRaportu+"?","Pytanie",.t.)
		return
	endif

	// tu powinna si zaczyna transakcja...
	SQL_PoprawaRekordu("rapcok",{ "PotwierdzoneRD"}, { 1 }, "NrKolejny="+cNrRaportu)
	
	cSQL :=	"UPDATE PISMA SET PotwierdzoneRD="+cNrRaportu+;
			" where NrKolejny in (Select NrKolejnyPisma from pozrapcok where NrKolejnyRaportu="+cNrRaportu+")"
	if SQL_DowolnySQL(cSQL)
		MsgBox("Pobieranie raportu zakoczone powodzeniem!")
	else
		MsgStop("Wystpi problem z pobieraniem raportu.")
	endif
	PrzygotujTabeleRaportowDoRD()
 return
 
*---------------------------
function ZmienRozmiarOknaRaportDoRD
	OknoRaportDoRD.G_PozRaportow.width := max(0, OknoRaportDoRD.Width - OknoRaportDoRD.G_PozRaportow.Col - 20)
 return
*---------------------------
function ZmienRozmiarOknaRaportCOK
	OknoRaportCOK.G_PozRaportow.width := max(0, OknoRaportCOK.Width - OknoRaportCOK.G_PozRaportow.Col - 45)
	OknoRaportCOK.T_RaportyCOK.width := max(0, OknoRaportCOK.Width - OknoRaportCOK.T_RaportyCOK.Col - 20)
 return
 