#include "dbstruct.ch"
#include "minigui.ch"
#include "common.ch"
#include "hbsqlit3.ch"
         
#define RDDI_CONNECT          1001
#define RDDI_EXECUTE          1003

*#DEFINE SQL_HBODBC
*#UNDEF SQL_SQLMIX

#UNDEF SQL_HBODBC
#DEFINE SQL_SQLMIX

function 	UstawPolaczenieZBazaDanych
	
	public SQL_Polaczenie
	
	
	do while .t.
		cConStr := "Driver={SQL Server};Server=" + cSQLSerwer + ";Database="+ cSQLBaza + ";Trusted_Connection=yes;Uid=" + cSQLUzytkownik + ";Pwd="+ cSQLHaslo +";"
		// msgbox(cConStr)
		#IFDEF SQL_HBODBC
			SQL_Polaczenie := TODBC():New( cConStr )
		#ENDIF
		
		#IFDEF SQL_SQLMIX
			// sddodbc
			RDDSETDEFAULT( "SQLMIX" )
			SET( 4, "yyyy-mm-dd" )
			WAIT WINDOW "Trwa nawizanie poczenia z serwerem bazy danych. Prosz czeka..." NOWAIT
			nConnection := RDDINFO( 1001, { "ODBC", cConStr }, 'SQLMIX' )
			WAIT CLEAR
			//msgbox("Connect: "+str(nConnection))
			If nConnection == 0
				MsgStop("Bd w podczeniu do bazy danych: " + cSQLBaza)
				if MsgYesNo("Prbowa zaoy baz danych: " + cSQLBaza + "?")
					cConStr := "Driver={SQL Server};Server=" + cSQLSerwer + ";Database="+ "master" + ";Trusted_Connection=yes;Uid=" + cSQLUzytkownik + ";Pwd="+ cSQLHaslo +";"
					nConnection := RDDINFO( 1001, { "ODBC", cConStr }, 'SQLMIX' )
					if nConnection == 0
						MsgStop("Operacja zakadania bazy danych: "+ cSQLBaza + " nie powioda si! Program zostanie zakoczony.")
						Release Window ALL
						Quit
					else
						if SQL_DowolnySQL("CREATE DATABASE " + cSQLBaza)
							loop
						else
							MsgStop("Bd podczas tworzenia bazy danych: "+cSQLBaza)
							quit
						endif
					endif
				else
					Release Window ALL
					Quit
				endif
			else
				exit
			Endif               	
		#ENDIF
	enddo
	// czy jest ju tabela?
	aTabele := SQL_GetColumn("information_schema.tables","Table_name","Table_name='PISMA'")
	//msgbox(hb_valtoexp(aTabele))
	if ascan(aTabele, {|x| upper(x) == "PISMA"}) = 0
		SQL_ZalozBazy()
		KonwertujDoSQL("pisma")
		KonwertujDoSQL("stodb")
		KonwertujDoSQL("up")
		KonwertujDoSQL("dotyczy")
	endif
return
*---------------------------
function SQL_GetArray
	param cNazwaTabeli, aListaPol, aTypyPol, cWarunek, cOrder

	local cZapytanie := "Select ", i, aRet := {}, aPom, nRow
	
	WAIT WINDOW "Trwa pobieranie wynikw" NOWAIT
	if cWarunek = NIL
		cWarunek := ""
	endif
	if cOrder = NIL
		cOrder := ""
	endif

	if aListaPol = NIL
		cZapytanie += "*"
	else
		for i:= 1 to len(aListaPol)
			cZapytanie += aListaPol[i] + ","
		next i
		cZapytanie := left(cZapytanie, len(cZapytanie)-1)
	endif
	
	cZapytanie += " from " + cNazwaTabeli
	if !empty(cWarunek)
		cZapytanie += " where "+cWarunek
	endif
	if !empty(cOrder)
		cZapytanie += " ORDER BY " + cOrder
	endif
	
	#IFDEF SQL_SQLMIX
		DBUSEAREA( .T.,, cZapytanie, "tempDBF" )
		if aListaPol = NIL
			aListaPol := {}
			for i:=1 to fcount()
				AAdd(aListaPol, Fieldname(i))
			next i
		endif
		do while !eof()
			aPom := {}
			for i:=1 to len(aListaPol)
				AAdd(aPom , SQL2Value(aTypyPol[i],FieldGet(i)))
			next i
			aadd(aRet, aPom)
			DBSkip()
		enddo
		DBCloseAll()
	#ENDIF
	#IFDEF SQL_HBODBC
		odp1 := SQL_Polaczenie:SetSQL(cZapytanie)
		odp2 := SQL_Polaczenie:Open()
		DO WHILE !SQL_Polaczenie:Eof()
			aPom := {}
			for i := 1 to len(aListaPol)
				aadd(aPom , SQL_Polaczenie:FieldByName(aListaPol[i]):Value)
			next i
			aadd(aRet, aPom)
			SQL_Polaczenie:Skip()
		ENDDO
		SQL_Polaczenie:Close()
	#ENDIF
	//CopyToClipboard(CzAPYTANIE)
	WAIT CLEAR
return aRet
*---------------------------
*---------------------------
function SQL_GetRow
	param cNazwaTabeli, aListaPol, aTypyPol, cWarunek
	local cZapytanie := "Select ", i, aRet := {}, aPom, nRow
	local xFormatDaty
   xFormatDaty := SET( _SET_DATEFORMAT, "yyyy-mm-dd" )

	if cWarunek = NIL
		cWarunek := ""
	endif
	if aListaPol = NIL
		cZapytanie += "*"
	else
		for i:= 1 to len(aListaPol)
			cZapytanie += aListaPol[i] + ","
		next i
		cZapytanie := left(cZapytanie, len(cZapytanie)-1)
	endif
	cZapytanie += " from " + cNazwaTabeli
	if !empty(cWarunek)
		cZapytanie += " where "+cWarunek
	endif
	
	#IFDEF SQL_SQLMIX
		//altd()
		DBUSEAREA( .T.,, cZapytanie, "tempDBF" )
		if aListaPol = NIL
			aListaPol := {}
			for i:=1 to fcount()
				AAdd(aListaPol, Fieldname(i))
				AAdd(aTypyPol, FieldType(i))
			next i
		endif
		if !eof()
			for i:=1 to len(aListaPol)
				AAdd(aRet, SQL2Value(aTypyPol[i],FieldGet(i)))
			next i
		endif
		DBCloseAll()
	#ENDIF
	#IFDEF SQL_HBODBC
		odp1 := SQL_Polaczenie:SetSQL(cZapytanie)
		odp2 := SQL_Polaczenie:Open()
		if !SQL_Polaczenie:Eof()
			for i := 1 to len(aListaPol)
				aadd(aRet , SQL_Polaczenie:FieldByName(aListaPol[i]):Value)
			next i
		endif
		SQL_Polaczenie:Close()
	#ENDIF

	SET( _SET_DATEFORMAT, xFormatDaty)
return aRet
*---------------------------
function SQL_GetColumn
	param cNazwaTabeli, cNazwaPola, cWarunek

	local cZapytanie := "Select ", i, aRet := {}, aPom, nRow
	local xFormatDaty
	
	xFormatDaty := SET( _SET_DATEFORMAT, "yyyy-mm-dd" )
	
	if cWarunek = NIL
		cWarunek := ""
	endif
	
	cZapytanie += cNazwaPola + " from " + cNazwaTabeli
	if !empty(cWarunek)
		cZapytanie += " where "+cWarunek
	endif
	
	#IFDEF SQL_SQLMIX
	altd()
		DBUSEAREA( .T.,, cZapytanie, "TempDBF" )
		do while !eof()
			aadd(aRet, FieldGet(1))
			DBSkip()
		enddo
		DBCloseAll()
	#ENDIF
	#IFDEF SQL_HBODBC
		odp1 := SQL_Polaczenie:SetSQL(cZapytanie)
		odp2 := SQL_Polaczenie:Open()
		DO WHILE !SQL_Polaczenie:Eof()
			aadd(aRet , SQL_Polaczenie:FieldByName(cNazwaPola):Value)
			SQL_Polaczenie:Skip()
		ENDDO
		SQL_Polaczenie:Close()
	#ENDIF

	SET( _SET_DATEFORMAT, xFormatDaty)

 return aRet
*------------------------------------------
function SQL_ZapisRekordu
	param cNazwaTabeli, aListaPol, aListaWartosci
	local cPolecenieSQL
	local lOdp := .f.
	local xFormatDaty
	
	xFormatDaty := SET( _SET_DATEFORMAT, "yyyy-mm-dd" )

	#IFDEF SQL_SQLMIX
			DBUSEAREA( .T.,,"SELECT NrKolejny FROM "+cNazwaTabeli +" ORDER BY NrKolejny DESC", "temp" )
			if LastRec() == 0
				NrKolejny := 1
			else
				NrKolejny := FieldGet(1)+1
			endif
			use
	#ENDIF
	
	&(cNazwaTabeli+"_NrKolejny") := NrKolejny
	
	//if cPolecenieSQL = NIL
		cPolecenieSQL := "INSERT INTO "+cNazwaTabeli + " (NrKolejny"
		for i:= 1 to len(aListaPol)
			
			cPolecenieSQL += ',' +aListaPol[i]
		next i
		cPolecenieSQL += ') VALUES (' + alltrim(str(NrKolejny))
		for i:= 1 to len(aListawartosci)
			cPolecenieSQL += ','+ c2sql(aListaWartosci[i])
		next i
		cPolecenieSQL += ')'
	//endif
		// przetwrz list pl na polecenie
	//CopyToClipboard(cPolecenieSQL)
		#IFDEF SQL_SQLMIX
			lodp := RDDINFO(RDDI_EXECUTE, cPolecenieSQL)
		#ENDIF

	SET( _SET_DATEFORMAT, xFormatDaty)

 	
 return lOdp
*------------------------------
function SQL_NowyNrKolejny
	param cNazwaTabeli
	#IFDEF SQL_SQLMIX
			DBUSEAREA( .T.,,"SELECT NrKolejny FROM "+cNazwaTabeli +" ORDER BY NrKolejny DESC", "temp" )
			if LastRec() == 0
				NrKolejny := 1
			else
				NrKolejny := FieldGet(1)+1
			endif
			use
	#ENDIF
	
 return NrKolejny
 
*----------------------------------------- 
function SQL_PoprawaRekordu
	param cNazwaTabeli, aListaPol, aListaWartosci, cWarunek
	local cPolecenieSQL
	local lOdp := .f., i, cLista := ""

	local xFormatDaty
	
	xFormatDaty := SET( _SET_DATEFORMAT, "yyyy-mm-dd" )

	cPolecenieSQL := "UPDATE " +cNazwaTabeli + " SET "
	cLista := ""
	for i:= 1 to len(aListaPol)
		cLista += "," +aListaPol[i] + "=" + C2SQL(aListaWartosci[i])
	next i
	cPolecenieSQL += substr(cLista,2)
	cPolecenieSQL += " WHERE "+cWarunek
	//msgbox(cPolecenieSQL)
	//CopyToClipboard(cPolecenieSQL)

	#IFDEF SQL_SQLMIX
		lodp := RDDINFO(RDDI_EXECUTE, cPolecenieSQL)
	#ENDIF
	SET( _SET_DATEFORMAT, xFormatDaty)

	
 return lOdp
*-------------------------------------
function SQL_UsunRekord
	param cNazwaTabeli, cWarunek
	local cPolecenieSQL
	local lOdp := .f., i, cLista := ""

	local xFormatDaty
	
	xFormatDaty := SET( _SET_DATEFORMAT, "yyyy-mm-dd" )

	cPolecenieSQL := "DELETE FROM " +cNazwaTabeli 
	if !empty(cWarunek)
		cPolecenieSQL += " WHERE " + cWarunek
	endif

	#IFDEF SQL_SQLMIX
		lodp := RDDINFO(RDDI_EXECUTE, cPolecenieSQL)
	#ENDIF
	SET( _SET_DATEFORMAT, xFormatDaty)

	
 return lOdp
*-------------------------------------*-------------------------------------
function SQL_DowolnySQL
	param cPolecenieSQL
	local lOdp := .f., i, cLista := ""

	local xFormatDaty
	
	xFormatDaty := SET( _SET_DATEFORMAT, "yyyy-mm-dd" )
	#IFDEF SQL_SQLMIX
		lodp := RDDINFO(RDDI_EXECUTE, cPolecenieSQL)
	#ENDIF
	SET( _SET_DATEFORMAT, xFormatDaty)	
 return lOdp
*-------------------------------------
function KonwertujdoSQL
	param cNazwaBazy
	local aRec, i, sQry
	local xFormatDaty
	local nIleRekordow, nRekord
	
	xFormatDaty := SET( _SET_DATEFORMAT, "yyyy-mm-dd" )

   if !file(sciezka+"bazy\"+cNazwaBazy+".dbf")
		MsgBox("Nie ma co konwertowa")
		SET( _SET_DATEFORMAT, xFormatDaty)

		return
	endif
	pracuje("rozpoczynam transfer "+cNazwaBazy)
	// usuwam istniejc tabel
	//	oQuery := RDDINFO(RDDI_EXECUTE, "DROP TABLE " + cNazwaBazy)
	
	//wait window "Transfer "+cNazwaBazy nowait
	use (sciezka+"bazy\"+cNazwaBazy) alias baza new shared via "DBFCDX"
   	select("baza")
	do case
		case cNazwaBazy = "dotyczy"
			go top
			do while !eof() 
				if empty(dotyczy)
					rlock()
					delete
				endif
				skip
			enddo
	endcase
	
   	go top
	
   	aRec := {} 
	aFields := {}
	cListaPol := "(NrKolejny,"
	ListaWart := ""
	for i:=1 to fcount()
		pole := FieldGet(i)
		
		NazwaPola := FieldName(i)
		
		TypPola := type("pole")
		do case
			case TypPola == "C"
				SQLTypPola := "Char("+alltrim(str(len(pole)))+")"
				
				WartPola := alltrim(pole)
			case TypPola == "D"
				SQLTypPola := "DATETIME"
				WartPola := Dtos(pole)
			case TypPola == "L"
				SQLTypPola := "INTEGER"
				WartPola := if(pole,"1","0")
			case TypPola == "N"
				SQLTypPola := "INTEGER"
				WartPola := alltrim(str(pole))
		endcase
		cListaPol += NazwaPola + ","
//		cCreateSQL += NazwaPola +" "+SQLTypPola+","
	next i

	cListaPol := substr(cListaPol,1,len(cListaPol)-1)+")"
//	#IFDEF SQL_HBODBC
//		odp1 := SQL_Polaczenie:SetSQL("drop table "+cNazwaBazy)
//		odp2 := SQL_Polaczenie:ExecSQL()
//		MsgBox("Usuwanie tabeli: "+cNazwaBazy+", z wynikami: "+hb_valtoexp(odp1)+":"+hb_valtoexp(odp2))
//		odp1 := SQL_Polaczenie:SetSQL( cCreateSQL )
//		odp2 := SQL_Polaczenie:ExecSQL()
//		MsgBox("Zakadanie tabeli: "+cNazwaBazy+", z wynikami: "+hb_valtoexp(odp1)+":"+hb_valtoexp(odp2)+;
//			chr(10)+"SQL: "+ SQL_Polaczenie:cSQL + chr(10)+ SQL_Polaczenie:SQLErrorMessage() ) 
		
//	#ENDIF
	
	pracuje("Trwa konwersja bazy "+cNazwaBazy)
	select("baza")
	go top
	nIleRekordow := reccount()
	//sQry := "INSERT INTO "+cNazwaBazy + cListaPol +  " VALUES ( " + str(NuRek)+","
	sQry2 :=""	
	NuRek := 1
	do while !eof()
		sQry2 := "INSERT INTO "+cNazwaBazy + cListaPol +  " VALUES (" + str(NuRek++)+","
		for i:=1 to fcount()
			pole := C2SQL(FieldGet(i))
			sQry2 += pole +","
		next i
		sQry2 := substr(sQry2,1,len(sQry2)-1) + "); "

		//memowrit("sql_insert_"+cNazwaBazy+".txt",sQry2)
		
		#IFDEF SQL_SQLMIX
			oQuery := RDDINFO(RDDI_EXECUTE, sQry2 )
			if !oQuery
				MsgBOX("bd zapisu "+ cNazwaBazy +" rekord#"+str(recno()))
				//if MsgYesNo("Przerwa?")
				//	exit
				//endif
			else
				//MsgBox("Transfer paczki do rekordu"+str(recno())+" -  OK")
			endif
			//oQuery:Destroy()			
		#ENDIF
		#IFDEF SQL_HBODBC
			SQL_Polaczenie:SetSQL(sQry2)
			SQL_Polaczenie:ExecSQL()
		#ENDIF
		sQry2 := ""

		//msgbox(str(Nurek))
		if Nurek%100 = 0
			//msgbox("przetworzono kolejne rekordw")
			pracuje("Trwa konwersja bazy "+cNazwaBazy+;
						chr(10)+"Przetworzono "+ alltrim(str(Nurek)) + " z "+alltrim(str(nIleRekordow)))
		endif
		
		skip
	enddo
	pracuje()
   	select("baza")
   	use

	do case
		case cNazwaBazy = "pisma"
			SQL_DowolnySQL(" update pisma set RejestracjaCOK=0, PotwierdzoneRD=1")
	endcase

   	SET( _SET_DATEFORMAT, xFormatDaty)
 return nil

*--------------------

function C2SQL(Value)

   local cValue := ""
    local cFormatoDaData := set(4)
   do case
      case Valtype(Value) == "N"
         cValue := AllTrim(Str(Value))

      case Valtype(Value) == "D"
	
        cValue := "'"+dtos(value)+"'"
		//if empty(cDate)
		//	cValue =""
		//else
			//cValue := "'"+strtran(cDate," ","0")+"'"
		//endif
		//cValue := "'"+left(cDate,4) +"."+substr(cDate,5,2)+"." +right(cDate,2)+"'"
		
      case Valtype(Value) $ "CM"
         IF Empty( Value)
            cValue="''"
         ELSE
            cValue := "'" + rtrim(charrepl("'",value,'"'))+ "'"
         ENDIF

      case Valtype(Value) == "L"
         cValue := iif(Value , "1", "0")

      otherwise
         cValue := "''"       // NOTE: Here we lose values we cannot convert

   endcase

return cValue
*-----------------------------------
function SQL2Value
	param cTypPola, xWartosc
	local xRet

	do case
		case cTypPola == "N"
			xRet := xWartosc
		case cTypPola == "C" .or. cTypPola == "M"
			xRet := xWartosc
			if xRet = NIL
				xRet := ""
			endif
		case cTypPola == "L"
			xret := !empty(xWartosc)
		case cTypPola == "D"
			if xWartosc = NIL
				xRet := ctod('')
			else
				if year(xWartosc) = 1900
					xRet := ctod('')
				else
					xRet := xWartosc
				endif
			endif
	otherwise
		xRet := hb_valtoexp(xWartosc)
	endcase
 return xRet
*-------------

function SQL_ZalozBazy
	param nNrBazy, lSilent
	
	local nNrTabeli
	local nZakresMin, nZakresMax
	local aListaTabel := {'pisma','up','stodb','dotyczy', 'rapcok','pozrapcok' , 'pocztowe','jedorg'}

	if type("nNrBazy") <> "N"
		nZakresMin	:= 1
		nZakresMax	:= len(aListaTabel)
	else
		nZakresMin	:= nNrBazy
		nZakresMax	:= nNrBazy
	endif
	
	if type('lSilent') <> "L"
		lSilent := .f.
	endif
	
	aPisma :=	{;
				{1, "NrKolejny", "int", .T., NIL},;
				{2, "RKDZ", "char", .T., 4},;
				{3, "NRDZ", "char", .T., 10},;
				{4, "DATAWPLYWU", "datetime", .T., NIL},;
				{5, "NRDZ_ZNAK", "char", .T., 40},;
				{6, "KLI_NAZWA", "char", .T., 80},;
				{7, "KLI_ULICA", "char", .T., 60},;
				{8, "KLI_MIASTO", "char", .T., 60},;
				{9, "KLI_POCZTA", "char", .T., 60},;
				{10, "DOTYCZY", "char", .T., 250},;
				{11, "UWAGI", "char", .T., 250},;
				{12, "DEK0", "char", .T., 10},;
				{13, "DEK0_DATA", "datetime", .T., NIL},;
				{14, "DEK1", "char", .T., 10},;
				{15, "DEK1_DATA", "datetime", .T., NIL},;
				{16, "DEK2", "char", .T., 10},;
				{17, "DEK2_DATA", "datetime", .T., NIL},;
				{18, "DEK3", "char", .T., 10},;
				{19, "DEK3_DATA", "datetime", .T., NIL},;
				{20, "DEK4", "char", .T., 10},;
				{21, "DEK4_DATA", "datetime", .T., NIL},;
				{22, "KOP0", "char", .T., 10},;
				{23, "KOP0_DATA", "datetime", .T., NIL},;
				{24, "KOP1", "char", .T., 10},;
				{25, "KOP1_DATA", "datetime", .T., NIL},;
				{26, "KOP2", "char", .T., 10},;
				{27, "KOP2_DATA", "datetime", .T., NIL},;
				{28, "KOP3", "char", .T., 10},;
				{29, "KOP3_DATA", "datetime", .T., NIL},;
				{30, "KOP4", "char", .T., 10},;
				{31, "KOP4_DATA", "datetime", .T., NIL},;
				{32, "BEZODP", "int", .T., NIL},;
				{33, "WYSLANE", "int", .T., NIL},;
				{34, "WYS_DATA", "datetime", .T., NIL},;
				{35, "WYS_ZNAK", "char", .T., 40},;
				{36, "WYS_DW", "char", .T., 80},;
				{37, "WYS_KOP1", "char", .T., 10},;
				{38, "WYS_KOP2", "char", .T., 10},;
				{39, "WYS_KOP3", "char", .T., 10},;
				{40, "WYS_KOP4", "char", .T., 10},;
				{41, "WYS_DOT", "char", .T., 200},;
				{42, "WYS_TYPL", "int", .T., NIL},;
				{43, "WYS_ERKA", "int", .T., NIL},;
				{44, "WYSLANEKOP", "int", .T., NIL},;
				{45, "WYS_DATAKO", "datetime", .T., NIL},;
				{46, "WYS_ZNAKKO", "char", .T., 40},;
				{47, "WYS_DWKO", "char", .T., 80},;
				{48, "WYS_KOPKO1", "char", .T., 10},;
				{49, "WYS_KOPKO2", "char", .T., 10},;
				{50, "WYS_KOPKO3", "char", .T., 10},;
				{51, "WYS_KOPKO4", "char", .T., 10},;
				{52, "WYS_DOTKO", "char", .T., 200},;
				{53, "WYS_TYPLKO", "int", .T., NIL},;
				{54, "WYS_ERKAKO", "int", .T., NIL},;
				{55, "NR_OP", "int", .T., NIL},;
				{56, "WYCHODZACE", "int", .T., NIL},;
				{57, "RejestracjaCOK", "int", .T., NIL},;
				{58, "PotwierdzoneRD", "int", .T., NIL},;
				{ 1, "NrKolejnyJT", "int", .T., NIL};
			}
		
	aUp :=	{;
				{1, "NrKolejny", "int", .T., NIL},;
				{2, "Nr", "int", .T., 30},;
				{2, "Nazwisko", "char", .T., 30},;
				{3, "Login", "char", .T., 20},;
				{4, "Pass", "char", .T., 20},;
				{5, "JedOrg", "char", .T., 6},;
				{6, "Str_start", "int", .T.,NIL},;
				{7, "UP_RE", "int", .T.,NIL},;
				{8, "UP_OB", "int", .T.,NIL},;
				{9, "UP_WY", "int", .T.,NIL} ,;
				{ 1, "NrKolejnyJT", "int", .T., NIL};
			}
				
	aStOdb :=	{;
				{1, "NrKolejny", "int", .T., NIL},;
				{2, "KLI_Nazwa", "char", .T., 80},;
				{3, "KLI_Ulica", "char", .T., 60},;
				{4, "KLI_Miasto", "char", .T., 60},;
				{5, "KLI_Poczta", "char", .T., 60} }
	aDotyczy :=	{;
				{1, "NrKolejny", "int", .T., NIL},;
				{2, "Dotyczy", "char", .T., 200} }
				
	aRapCok	:= 	{;
				{1, "NrKolejny", "int", .T., NIL},;
				{2, "DataRaportu", "datetime", .T., NIL} ,;
				{3, "PotwierdzoneRD", "int", .T., NIL}}

	aPozRapCok := {;
				{1, "NrKolejny", "int", .T., NIL},;
				{2, "NrKolejnyRaportu", "int", .T., NIL} ,;
				{3, "NrKolejnyPisma", "int", .T., NIL} }
	aPocztowe:=	{;
				{ 1, "NrKolejny", "int", .T., NIL},;
				{ 2, "Data", "datetime", .T., NIL} ,;
				{ 3, "NrKolejnyPisma", "int", .T., NIL} ,;
				{ 4, "CzyKopia", "int", .T.,NIL},;
				{ 5, "Wydrukowane", "int", .T.,NIL} 	}
	aJedOrg:=	{;
				{ 1, "NrKolejny", "int", .T., NIL},;
				{2, "NazwaJednostki", "char", .T., 80} }
		
		for nNrTabeli := nZakresMin to nZakresMax
			aStrukturaTabeli := &('a'+aListaTabel[nNrTabeli])
			cCreateSQL := "CREATE TABLE "+aListaTabel[nNrTabeli] + " ( NrKolejny int NOT NULL, PRIMARY KEY (NrKolejny),"
			for i := 2 to len(aStrukturaTabeli)
				cNazwaPola	:= aStrukturaTabeli[i,2]
				cSQLTypPola	:= aStrukturaTabeli[i,3]
				if cSQLTypPola == "char"
					cSQLTypPola := "Char("+alltrim(str(aStrukturaTabeli[i,5]))+")"
				endif
				cCreateSQL += cNazwaPola +" "+cSQLTypPola+","
			next i

			// trzeba odci ostatni przecinek
			cCreateSQL := substr(cCreateSQL,1,len(cCreateSQL)-1) + ")"

			// zakadamy tabel
			memowrit("sql_zakl_"+aListaTabel[nNrTabeli]+".txt", cCreateSQL )

			#IFDEF SQL_SQLMIX
				oQuery := RDDINFO(RDDI_EXECUTE, cCreateSQL )
				if !oQuery
					if !lSilent
						MsgStop("Bd podczas tworzenia tabeli "+ aListaTabel[nNrTabeli])
					endif
				endif
			#ENDIF
		next nNrTabeli
		
		// w tabeli up zakadamy uytkownika administrator
		SQL_ZapisRekordu("up",{"NrKolejny","Nr","Nazwisko","login","pass"}, {1,999,"administrator","adm","adm"})
 return
*--------------------------------
